//+------------------------------------------------------------------+
//|                                                painted stoch.mq4 |
//|                                                           .....h |
//|                                                 hayseedville.com |
//+------------------------------------------------------------------+
#property copyright ".....h"
#property link      "hayseedville.com"

#property  indicator_chart_window
#property  indicator_buffers 8
#property  indicator_color1  Blue
#property  indicator_color2  Red
#property  indicator_color3  Blue
#property  indicator_color4  Red
#property  indicator_color5  Blue
#property  indicator_color6  White


extern int  periods        =  15;
extern int  method         =   3;      
extern bool alert          =true;

double     ind_buffer1[];
double     ind_buffer2[];

int        HighBarBuffer[];
int        LowBarBuffer[];

//---- indicator buffers
double     CrossUp[];
double     CrossDown[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
 
  {

   //----
   IndicatorBuffers(8);
   
   //---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,3);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,3);
   
   SetIndexBuffer(2, HighBarBuffer);
   SetIndexBuffer(3, LowBarBuffer);

   
    
   
  IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
   
  
   if(!SetIndexBuffer(0,ind_buffer1) && !SetIndexBuffer(1,ind_buffer2)
   && !SetIndexBuffer(2,HighBarBuffer) && !SetIndexBuffer(3,LowBarBuffer))
      Print("cannot set indicator buffers!");
      
   
   //---- initialization done
   return(0);
   
  }
  
 //------------------------------------------------------------------
 int deinit()
   { 
   
   ObjectDelete("Label701");
    return(0);
   } 
 
   bool NewBar()
   {
   static datetime lastbar;
   datetime curbar = Time[0];
  
   if(lastbar!=curbar)
   {
      lastbar=curbar;
      return (true);
   }
   else
   {
      return(false);
   }
   }   

 
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
  drawLabel("Label701"," trend bars painted",15,Lime,50,50,"Arial");
   int      limit,i,counter; 
   int      counted_bars=IndicatorCounted();
   double Range, AvgRange;
   
   if(counted_bars<0) return(-1);
   
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   for( i=0; i<limit; i++)
   {
      counter=i;
      Range=0;
      AvgRange=0;
      for (counter=i ;counter<=i+9;counter++) {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
    Range      =AvgRange/10;
    
   
    double trend                  = iCustom(NULL, 0, "Trend Bars",periods,method,0,2,i);
    double trend2                 = iCustom(NULL, 0, "Trend Bars",periods,method,0,2,i+1);  
    
     
      if(trend > 0)
       {
         ind_buffer2[i] = Low[i];
         ind_buffer1[i] = High[i];
       }

      if(trend < 0)
       {
         ind_buffer1[i] = Low[i];
         ind_buffer2[i] = High[i];
       }
     
    
     if(alert == true &&  NewBar())
     {    
     if ((trend > 0) && (trend2 < 0))
     {
     Alert("possible positive trend change " , Symbol(), " ",Period(),"min @", Close[0],"!!!");
     PlaySound("alert.wav");
     SendMail("trend alert", "possible positive trend change" + Symbol());
     }
     if ((trend < 0 ) && (trend2 > 0)) 
     {
     Alert("possible negative trend change ", Symbol()," ",Period(),"min @", Close[0],"!!!");
     PlaySound("alert.wav");
     SendMail("trend alert", "possible negative trend change" + Symbol());
     }
     }
     }
      
     
      
      
      
      
      
      
   return(0);
      }
  
  void drawLabel(string id, string text,int fsize, color fcolor,int x,int y,string font="Arial",int window = 0)
      {
      if(ObjectFind(id)==-1)
      { 
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 0);
        ObjectSet(id, OBJPROP_XDISTANCE, x);
        ObjectSet(id, OBJPROP_YDISTANCE, y);
      }
      else
      {
        
        ObjectDelete(id);
         
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 0);
        ObjectSet(id, OBJPROP_XDISTANCE, x);
        ObjectSet(id, OBJPROP_YDISTANCE, y);   
      }  
      }